UBXTOOL(1)

NAME
ubxtool - u-blox tool

SYNOPSIS

ubxtool [-?] [-c command] [-d disable] [-e enable] [-f file/device] [-h] [-m mode] [-p preset] [-R rawfile] [-r] [-S setspeed] [-s speed] [-V] [-v verbosity] [-w wait] [[server[:port[:device]]]]

DESCRIPTION

ubxtool is a tool for u-blox GPS. If you do not have a u-blox GPS then can stop reading now.

This tool operates with your u-blox GPS at a very low level. To understand ubxtool you must first be familiar with your u-blox GPS and the documentation for the u-blox binary protocol. The u-blox protocol varies greatly depending o GPS model and firmware revision.

ubxtool can decode common u-blox binary messages, poll the GPS status, enable and disable GPS features, and send user generated commands to the GPS. It can read binary messages from a file. It can read and write directly through a serial device, or through a running gpsd instance.

OPTIONS

The program accepts the following options:

-c COMMAND
    Send a text string to the GPS. Accepts one parameter, COMMAND, the command string to send to the GPS. The string is sent verbatim, except a newline is appended.

-d OPTION
    Disable an option in the GPS. Accepts one parameter, OPTION, the option to disable.

    BEIDOU
        Disable use of the BeiDou (COMPASS) constellation.

    BINARY
        Disable sending of the basic binary messages.

    ECEF
        Disable sending of ECEF binary messages.

    GALILEO
        Disable use of the GALILEO constellation.

    GLONASS
        Disable use of the GLONASS constellation.

    GPS
        Disable use of the GPS and QZSS constellations.

    NMEA
        Disable sending basic NMEA messages. The messages are GBS, GGA, GSA, GGL, GST, GSV, RMC, VTG, and ZDA.

    RAWX
        Disable sending of the UBX-RXM-RAWX messages.

    SBAS
        Disable use of the SBAS constellation.

    TMODE2
        Disable sending TMODE2.

    TP
        Disable sending UBX-TIM-TP.

-e OPTION
    Enable an option in the GPS. Accepts one parameter, OPTION, the option to enable. -e accepts the same OPTIONs as -d, except the action is to enable the option.

-f FILE
    Connect to a file or device. Accepts one parameter, FILE, the file or device to open. Files are opened read-only. Character devices are opened red/write, unless the -r parameter is given.

-h
    Makes ubxtool print a usage message and exit.

-m mode
    Sets optional mode parameter to a -p PRESET command.

-p PRESET
    Send a preset command the GPS. Accepts one parameter, PRESET, the name of the command to send. ubxtool will exit after the GPS acknowledges the command, unless the -W is given.

    ANT
        Poll the antenna configuration (UBX-CFG-ANT).

    COLDBOOT
        Coldboot the GPS (UBX-CFG-RST).

    GNSS
        Poll the enabled constellations (UBX-CFG-GNSS).

    HOTBOOT
        Hotboot the GPS (UBX-CFG-RST).

    MODEL
        Configure the Dynamic Platform Model. (UBX-CFG-NAV5).

    NAV5
        Poll the Nav Engines settings (UBX-CFG-NAV6.

    RESET
        Reset configuration to defaults (UBX-CFG-CFG).

    SAVE
        Save current configuration (UBX-CFG-CFG).

    SVIN
        Poll survey in data (UBX-CFG-SVIN).

    TMODE2
        Poll Time Mode 2 configuration (UBX-CFG-TMODE2).

    TP
        Poll time pulse timedata (UBX-TIM-TP).

    TP5
        Get Time Pulse decodes (UBX-TIM-TP5).

    VER
        Poll GPS version.

    WARMBOOT
        Warmboot the GPS (UBX-CFG-RST).

-R RAW
    Save all raw data from the GPS into the file RAW.

-r
    Read only. Do not send anything to the GPS.

-S SPEED
    Set the GPS serial port speed to SPEED bps.

-s SPEED
    Set local serial port speed to SPEED bps. Default 115,200 bps.

-V
    Print ubxtool version and exit.

-v VERBOSITY
    Set verbosity level to VERBOSITY. Verbosity can be from 0 (very quiet), to 4 (very noisy). Default 2.

-v VERBOSITY
    Set verbosity level to VERBOSITY. Verbosity can be from 0 (very quiet), 2 (decode messages), to 4 (very noisy). Default 1.

-w WAIT
    Wait for WAIT seconds before exiting. Will exit early on command completion of -d, -e or -p command, unless -W is given. Default 2.0 second.

-?
    Makes ubxtool print a usage message and exit.

[server[:port[:device]]]
    By default, ubxtool collects data from all compatible devices on localhost, using the default GPSD port 2947. An optional argument may specify a server to get data from. A colon-separated suffix is taken as a port number. If there is a second colon-separated suffix, that is taken as a specific device name to be watched. Further details on the gps(1) man page.

ENVIRONMENT

Options can be placed in the UBXOPTS environment variable. UBXOPTS is processed before the CLI options.

EXAMPLES

Decode raw log file:

    ubxtool -r -f ublox-neo-m8n.log

Change GPS port speed of device on /dev/ttyAMA0 to 230,400 bps::

    ubxtool -S 230400 -f /dev/ttyAMA0

Watch entire GPS reset cycle, include $GPTXT messages:

    ubxtool -p COLDBOOT -w 20 -v 2

Poll Enabled Constellations:

    ubxtool -p GNSS

Dump gpsd data from remote server:

    ubxtool -w 5 server

SEE ALSO

ubxtool is written to conform to the official u-blox documentation for the u-blox binary protocol. https://www.u-blox.com/en/product-resources

gpsd(8), gps(1), cgps(1), xgps(1), gpsfake(1), gpsctl(1), gpscat(1), gnuplot(1).

AUTHOR

Gary E. Miller<gem@rellim.com>